package main

import "unsafe"

type ServiceContext uintptr
type ServiceRndvContext uintptr
type NetChannel uintptr
type NetService uintptr
type ServiceRspCtx uintptr
type MemoryAllocator uintptr
type MemoryRegion uintptr
type Memory uintptr

type NewEndPointHandler unsafe.Pointer
type BrokenEndPointHandler unsafe.Pointer
type RequestReceivedHandler unsafe.Pointer
type RequestPostHandler unsafe.Pointer
type OneSideDoneHandler unsafe.Pointer
type RndvMemAllocateHandler unsafe.Pointer
type RndvMemFreeHandler unsafe.Pointer
type RndvHandler unsafe.Pointer
type TlsGetCertCb unsafe.Pointer
type TlsGetPrivateKeyCb unsafe.Pointer
type TlsGetCACb unsafe.Pointer
type ServiceLogHandler unsafe.Pointer
type ChannelCallbackFunc unsafe.Pointer
type MessageData unsafe.Pointer
type MemoryPointer unsafe.Pointer

type ServiceContextType int

const (
	Received ServiceContextType = 0
	Sent     ServiceContextType = 2
)

type ServiceRndvType int

const (
	Rndv ServiceRndvType = 0
)

type ServiceType int

const (
	RDMA ServiceType = 0
	TCP  ServiceType = 1
)

type ServiceChannelPolicy int

const (
	BrokenAll ServiceChannelPolicy = 0 /* when one ep broken, all eps broken */
	Reconnect ServiceChannelPolicy = 1 /* when one ep broken, try re-connect first. If re-connect fail, broken all eps */
	KeepAlive ServiceChannelPolicy = 2 /* when one ep broken, keep left eps alive until all eps broken */
)

type AllocatorType int

const (
	DynamicSize          AllocatorType = 0 /* allocate dynamic memory size, there is alignment with X KB */
	DynamicSizeWithCache AllocatorType = 1 /* allocator with dynamic memory size, with pre-allocate cache for performance */
)

type AllocatorCacheTierPolicy int

const (
	Times AllocatorCacheTierPolicy = 0 /* tier by times of min-block-size */
	Power AllocatorCacheTierPolicy = 1 /* tier by power of min-block-size */
)

type NetCipherSuite int

const (
	AES_GCM_128       NetCipherSuite = 0
	AES_GCM_256       NetCipherSuite = 1
	AES_CCM_128       NetCipherSuite = 2
	CHACHA20_POLY1305 NetCipherSuite = 3
)

type TlsMode uint32

const (
	OPENSSL       TlsMode = 0
	HITLS         TlsMode = 1
)

type NetPeerCertVerifyType int

const (
	VerifyByNone       NetPeerCertVerifyType = 0 /* don't verify peer certification */
	VerifyByDefault    NetPeerCertVerifyType = 1 /* verify peer certification by what hcom provided, crl check and cert check */
	VerifyByCustomFunc NetPeerCertVerifyType = 2 /* verify peer certification using caller's */
)

const (
	NO64  = 64
	NO128 = 128
	NO256 = 256
)